--[[ Local                                                            ]]
local _G = getfenv(0);
local LibStub = _G["LibStub"];
local AddOn = LibStub("AceAddon-3.0"):GetAddon("Enhancer");
local L = LibStub("AceLocale-3.0"):GetLocale("Enhancer")

--[[ Print/Debug                                                      ]]
local print = function(...) AddOn:PrintFunction(...); end
local debug = function(...) AddOn:DebugFunction(...); end

AddOn.guids = {};
function AddOn:CombatLogEvent(combatLogEventType, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	if (event == "SPELL_SUMMON" and self:LogIsPlayer(sourceFlags)) then
		AddOn.guids[destName] = destGUID;
	elseif (event == "SWING_DAMAGE" and self:LogIsPlayer(destFlags)) then
		dmg = select("1", ...);
		
		for slot, button in pairs(self.totems) do
			if (button:Get("guid") == destGUID and button:Get("hp")) then
				button:Set("hp", button:Get("hp") - dmg);
			end
		end
	end
	
	--fprint(ChatFrame3, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...);
end

function AddOn:LogIsPlayer(flags)
	return (bit.band(flags, 0x00000001) == 0x00000001);
end