--[[ Local                                                            ]]
local _G = getfenv(0);
local LibStub = _G["LibStub"];
local AddOn = LibStub("AceAddon-3.0"):GetAddon("Enhancer");
local L = LibStub("AceLocale-3.0"):GetLocale("Enhancer");

local gsub, trim = _G.string.gsub, _G.strtrim;

function AddOn:QueueMacro(slot, name)
	local totem, rank = self:TotemAndRank(name);
	
	if (self.db.profile.quickCast[slot] == "") then
		self.queue[slot] = totem;
		self:DoQueue();
	end
end

function AddOn:DoQueue() -- Called on by CombatEnd
	if (self.combat) then return; end
	
	for slot, name in pairs(self.queue) do
		local button = self.totems[slot];
		self.queue[slot] = nil;
		if (self.db.profile.quickCast[slot] == "") then
			button:SetMacro("/script DestroyTotem(" .. slot .. ");\n/cast " .. name)
			button:SetText("Cast: " .. trim(gsub(name, L["Totem gsub"], "")), "Top");
		end
	end
end

function AddOn:SetQueue(slot, value)
	value = trim(value);
	self.db.profile.quickCast[slot] = value;
	
	if (value ~= "") then
		self.totems[slot]:SetMacro("/script DestroyTotem(" .. slot .. ");\n/cast " .. value)
		self.totems[slot]:SetText("Cast: " .. trim(gsub(value, L["Totem gsub"], "")), "Top");
	end
end